diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/model/dhcp6-duid.h ns-3.47/src/internet-apps/model/dhcp6-duid.h
--- ns-3.46/src/internet-apps/model/dhcp6-duid.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/model/dhcp6-duid.h	2026-02-16 16:08:49.604230000 -0800
@@ -26,11 +26,6 @@
 class Duid
 {
   public:
-    /**
-     * @brief Default constructor.
-     */
-    Duid();
-
     /// DUID type.
     enum class Type
     {
@@ -52,7 +47,7 @@
         /**
          * @brief Returns the hash of a DUID.
          * @param x the DUID
-         * @return the hash
+         * @returns the hash
          *
          * This method uses std::hash rather than class Hash
          * as speed is more important than cryptographic robustness.
@@ -61,68 +56,75 @@
     };
 
     /**
-     * @brief Initialize the DUID for a client or server.
-     * @param node The node for which the DUID is to be generated.
-     */
-    void Initialize(Ptr<Node> node);
-
-    /**
-     * @brief Check if the DUID is invalid.
-     * @return true if the DUID is invalid.
+     * Initialize a DUID.
+     *
+     * The DUID initialization logic is the following:
+     *   - DUID-LLT and DUID-LL: the identifier is created by selecting
+     *     the NetDevices with the longest MAC address length, and among
+     *     them, the one with the smallest index.
+     *   - DUID-LLT: the creation time is taken from the simulation time.
+     *   - DUID-EN: the Enterprise number is 0xf00dcafe (arbitrary number,
+     *     currently unused), and the identifier is based on the Node ID.
+     *   - DUID-UUID: the UUID is based on the Node ID.
+     *
+     * @param duidType the DUID type.
+     * @param node the node this DUID refers to
+     * @param enIdentifierLength the DUID-EN identifier length (unused in other DUID types)
      */
-    bool IsInvalid() const;
+    void Initialize(Type duidType, Ptr<Node> node, uint32_t enIdentifierLength);
 
     /**
-     * @brief Get the DUID type
-     * @return the DUID type.
+     * @brief Initialize the DUID-LL for a client or server.
+     * @param node The node for which the DUID is to be generated.
      */
-    Type GetDuidType() const;
+    void InitializeLL(Ptr<Node> node);
 
     /**
-     * @brief Set the DUID type
-     * @param duidType the DUID type.
+     * @brief Initialize the DUID-LLT for a client or server.
+     * @param node The node for which the DUID is to be generated.
      */
-    void SetDuidType(Type duidType);
+    void InitializeLLT(Ptr<Node> node);
 
     /**
-     * @brief Get the hardware type.
-     * @return the hardware type
+     * @brief Initialize the DUID-EN for a client or server.
+     * @param enNumber The Enterprise Number.
+     * @param identifier The device Identifier.
      */
-    uint16_t GetHardwareType() const;
+    void InitializeEN(uint32_t enNumber, const std::vector<uint8_t>& identifier);
 
     /**
-     * @brief Set the hardware type.
-     * @param hardwareType the hardware type.
+     * @brief Initialize the DUID-EN for a client or server.
+     * @param uuid The UUID.
      */
-    void SetHardwareType(uint16_t hardwareType);
+    void InitializeUUID(const std::vector<uint8_t>& uuid);
 
     /**
-     * @brief Set the identifier as the DUID.
-     * @param identifier the identifier of the node.
+     * @brief Check if the DUID is invalid.
+     * @returns true if the DUID is invalid.
      */
-    void SetDuid(std::vector<uint8_t> identifier);
+    bool IsInvalid() const;
 
     /**
-     * @brief Get the time at which the DUID is generated.
-     * @return the timestamp.
+     * @brief Get the DUID type
+     * @returns the DUID type.
      */
-    Time GetTime() const;
+    Type GetDuidType() const;
 
     /**
      * @brief Get the length of the DUID.
-     * @return the DUID length.
+     * @returns the DUID length.
      */
     uint8_t GetLength() const;
 
     /**
-     * @brief Set the time at which DUID is generated.
-     * @param time the timestamp.
+     * @brief Return the identifier of the node.
+     * @returns the identifier.
      */
-    void SetTime(Time time);
+    std::vector<uint8_t> GetIdentifier() const;
 
     /**
      * @brief Get the DUID serialized size.
-     * @return The DUID serialized sized in bytes.
+     * @returns The DUID serialized sized in bytes.
      */
     uint32_t GetSerializedSize() const;
 
@@ -136,65 +138,88 @@
      * @brief Deserialize the DUID.
      * @param start The buffer iterator.
      * @param len The number of bytes to be read.
-     * @return The number of bytes read.
+     * @returns The number of bytes read.
      */
     uint32_t Deserialize(Buffer::Iterator start, uint32_t len);
 
     /**
-     * @brief Comparison operator
-     * @param duid header to compare
-     * @return true if the headers are equal
+     * @brief Comparison operator.
+     *
+     * @note Defined because gcc-13.3 raises an error in optimized builds.
+     * Other than that, the comparison is semantically identical to the default one.
+     *
+     * @param other DUID to compare to this one.
+     * @return true if the duids are equal.
      */
-    bool operator==(const Duid& duid) const;
+    bool operator==(const Duid& other) const;
 
     /**
-     * @brief Less than operator.
+     * Spaceship comparison operator. All the other comparison operators
+     * are automatically generated from this one.
      *
-     * @param a the first operand
-     * @param b the first operand
-     * @returns true if the operand a is less than operand b
+     * @note Defined because gcc-13.3 raises an error in optimized builds.
+     * Other than that, the comparison is semantically identical to the default one.
+     *
+     * @param a left operand DUID to compare.
+     * @param b right operand DUID to compare.
+     * @returns The result of the comparison.
      */
-    friend bool operator<(const Duid& a, const Duid& b);
+    friend std::strong_ordering operator<=>(const Duid& a, const Duid& b);
 
-    // TypeId GetInstanceTypeId() const override;
-    // void Print(std::ostream& os) const override;
-    // uint32_t GetSerializedSize() const override;
-    // void Serialize(Buffer::Iterator start) const override;
-    // uint32_t Deserialize(Buffer::Iterator start) override;
+    /**
+     * @brief Stream output operator.
+     *
+     * The DUID is printed according to its type, e.g.:
+     *   - DUID-LL HWtype: 1 Identifier: 0x000000000002
+     *   - DUID-LLT HWtype: 1 Time: 0 Identifier: 0x000000000002
+     *   - DUID-EN EnNumber: 0xf00dcafe Identifier: 0x000102030405060708090a
+     *   - DUID-UUID UUID: 0x000102030405060708090a0b0c0d0e0f
+     *
+     * @param os output stream
+     * @param duid The reference to the DUID object.
+     * @returns updated stream
+     */
+    friend std::ostream& operator<<(std::ostream& os, const Duid& duid);
 
   private:
     /**
-     * @brief Return the identifier of the node.
-     * @return the identifier.
+     * DUID data offset.
+     *
+     * Each DUID has some fixed-length fields (e.g., Hardware Type), and a
+     * variable length part. This is the offset to the variable length part.
      */
-    std::vector<uint8_t> GetIdentifier() const;
+    enum Offset
+    {
+        LLT = 6,
+        EN = 4,
+        LL = 2,
+        UUID = 0
+    };
 
     /**
-     * Type of the DUID.
-     * We currently use only DUID-LL, based on the link-layer address.
+     * Find a suitable NetDevice address to create a DUID-LL or DUID-LLT.
+     *
+     * We select the NetDevices with the longest MAC address length,
+     * and among them, the one with the smallest index.
+     *
+     * @param node The node for which the DUID is to be generated.
+     * @returns the L2 address for the DUID Hardware Identifier.
      */
-    Type m_duidType;
+    Address FindSuitableNetDeviceAddress(Ptr<Node> node);
 
-    uint16_t m_hardwareType;           //!< Valid hardware type assigned by IANA.
-    Time m_time;                       //!< Time at which the DUID is generated. Used in DUID-LLT.
-    std::vector<uint8_t> m_identifier; //!< Identifier of the node in bytes.
-};
+    /**
+     * Utility function to convert a 32-bit number to
+     * an array with its bytes in network order.
+     *
+     * @param[in] source the number to convert.
+     * @param[out] dest the converted number.
+     */
+    void HtoN(uint32_t source, std::vector<uint8_t>::iterator dest);
 
-/**
- * @brief Stream output operator
- * @param os output stream
- * @param duid The reference to the DUID object.
- * @return updated stream
- */
-std::ostream& operator<<(std::ostream& os, const Duid& duid);
-
-/**
- * Stream extraction operator
- * @param is input stream
- * @param duid The reference to the DUID object.
- * @return std::istream
- */
-std::istream& operator>>(std::istream& is, Duid& duid);
+    Type m_duidType{Duid::Type::LL}; //!< DUID type.
+
+    std::vector<uint8_t> m_blob{}; //!< DUID data, content depending on the DUID type.
+};
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/model/dhcp6-header.cc ns-3.47/src/internet-apps/model/dhcp6-header.cc
--- ns-3.46/src/internet-apps/model/dhcp6-header.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/model/dhcp6-header.cc	2026-02-16 16:08:49.604230000 -0800
@@ -142,8 +142,7 @@
                                  Options::OptionType optionType,
                                  Duid duid)
 {
-    // DUID type (2 bytes) + hw type (2 bytes) + Link-layer Address (variable)
-    uint16_t duidLength = 2 + 2 + duid.GetLength();
+    uint16_t duidLength = duid.GetSerializedSize();
 
     // Set the option code, length, hardware type, link layer address.
     identifier.SetOptionCode(optionType);
@@ -513,7 +512,7 @@
 
                     // Read DUID.
                     Duid duid;
-                    uint32_t read = duid.Deserialize(i, duidLength - 4);
+                    uint32_t read = duid.Deserialize(i, duidLength);
                     i.Next(read);
                     m_clientIdentifier.SetDuid(duid);
                     len += m_clientIdentifier.GetOptionLength();
@@ -535,7 +534,7 @@
 
                 // Read DUID.
                 Duid duid;
-                uint32_t read = duid.Deserialize(i, duidLength - 4);
+                uint32_t read = duid.Deserialize(i, duidLength);
                 i.Next(read);
                 m_serverIdentifier.SetDuid(duid);
                 len += m_serverIdentifier.GetOptionLength();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/model/dhcp6-options.cc ns-3.47/src/internet-apps/model/dhcp6-options.cc
--- ns-3.46/src/internet-apps/model/dhcp6-options.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/model/dhcp6-options.cc	2026-02-16 16:08:49.604230000 -0800
@@ -66,28 +66,6 @@
 {
 }
 
-IdentifierOption::IdentifierOption(uint16_t hardwareType, Address linkLayerAddress, Time time)
-{
-    NS_LOG_FUNCTION(this << hardwareType << linkLayerAddress);
-    if (time.IsZero())
-    {
-        m_duid.SetDuidType(Duid::Type::LL);
-    }
-    else
-    {
-        m_duid.SetDuidType(Duid::Type::LLT);
-    }
-
-    m_duid.SetHardwareType(hardwareType);
-
-    uint8_t buffer[16];
-    linkLayerAddress.CopyTo(buffer);
-
-    std::vector<uint8_t> identifier;
-    std::copy(buffer, buffer + linkLayerAddress.GetLength(), identifier.begin());
-    m_duid.SetDuid(identifier);
-}
-
 void
 IdentifierOption::SetDuid(Duid duid)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/model/dhcp6-options.h ns-3.47/src/internet-apps/model/dhcp6-options.h
--- ns-3.46/src/internet-apps/model/dhcp6-options.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/model/dhcp6-options.h	2026-02-16 16:08:49.604230000 -0800
@@ -139,14 +139,6 @@
     IdentifierOption();
 
     /**
-     * @brief Constructor.
-     * @param hardwareType The hardware type.
-     * @param linkLayerAddress The link-layer address.
-     * @param time The time at which the DUID is generated.
-     */
-    IdentifierOption(uint16_t hardwareType, Address linkLayerAddress, Time time = Time());
-
-    /**
      * @brief Set the DUID.
      * @param duid The DUID.
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/model/dhcp6-server.cc ns-3.47/src/internet-apps/model/dhcp6-server.cc
--- ns-3.46/src/internet-apps/model/dhcp6-server.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/model/dhcp6-server.cc	2026-02-16 16:08:49.604230000 -0800
@@ -12,7 +12,9 @@
 #include "dhcp6-duid.h"
 
 #include "ns3/address-utils.h"
+#include "ns3/enum.h"
 #include "ns3/icmpv6-l4-protocol.h"
+#include "ns3/integer.h"
 #include "ns3/ipv6-interface.h"
 #include "ns3/ipv6-l3-protocol.h"
 #include "ns3/ipv6-packet-info-tag.h"
@@ -61,7 +63,24 @@
                           "4000 seconds by default in Linux.",
                           TimeValue(Seconds(4000)),
                           MakeTimeAccessor(&Dhcp6Server::m_validLifetime),
-                          MakeTimeChecker());
+                          MakeTimeChecker())
+            .AddAttribute("DuidType",
+                          "Configure the type of DUID used by the server.",
+                          EnumValue(Duid::Type::LL),
+                          MakeEnumAccessor<Duid::Type>(&Dhcp6Server::m_duidType),
+                          MakeEnumChecker(Duid::Type::LLT,
+                                          "LLT",
+                                          Duid::Type::EN,
+                                          "EN",
+                                          Duid::Type::LL,
+                                          "LL",
+                                          Duid::Type::UUID,
+                                          "UUID"))
+            .AddAttribute("DuidEnIdentifierLength",
+                          "Length of the identifier of the DUID-EN.",
+                          IntegerValue(8),
+                          MakeIntegerAccessor(&Dhcp6Server::m_DuidEnIdentifierLength),
+                          MakeIntegerChecker<uint16_t>(4, 65529));
 
     return tid;
 }
@@ -160,11 +179,6 @@
     // Available address pools and IA information is sent in this option.
     for (auto& subnet : m_subnets)
     {
-        Ipv6Address pool = subnet.GetAddressPool();
-        Ipv6Prefix prefix = subnet.GetPrefix();
-        Ipv6Address minAddress = subnet.GetMinAddress();
-        Ipv6Address maxAddress = subnet.GetMaxAddress();
-
         /*
          * Find the next available address. Checks the expired address map.
          * If there are no expired addresses, it advertises a new address.
@@ -210,6 +224,7 @@
         {
             // Allocate a new address.
             uint8_t minAddrBuf[16];
+            Ipv6Address minAddress = subnet.GetMinAddress();
             minAddress.GetBytes(minAddrBuf);
 
             // Get the latest leased address.
@@ -667,10 +682,6 @@
         return;
     }
 
-    // Initialize the DUID before responding to the client.
-    Ptr<Node> node = GetNode();
-    m_serverDuid.Initialize(node);
-
     if (header.GetMessageType() == Dhcp6Header::MessageType::SOLICIT)
     {
         ProcessSolicit(iDev, header, senderAddr);
@@ -778,6 +789,19 @@
         icmpv6->SetDhcpv6Callback(MakeCallback(&Dhcp6Server::ReceiveMflag, this));
     }
 
+    // Initialize the DUID before responding to the client.
+    if (m_serverDuid.IsInvalid())
+    {
+        Ptr<Node> node = GetNode();
+        // We use enterprise-number 0xf00dcafe (totally arbitrary)
+        // The current largest enterprise number is less than 0xffff, which means
+        // we use an unused number.
+        // The list of numbers is at
+        // https://www.iana.org/assignments/enterprise-numbers/
+        m_serverDuid.Initialize(m_duidType, node, m_DuidEnIdentifierLength);
+        NS_LOG_INFO("DHCPv6 server DUID created: " << m_serverDuid);
+    }
+
     m_leaseCleanupEvent = Simulator::Schedule(m_leaseCleanup, &Dhcp6Server::CleanLeases, this);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/model/dhcp6-server.h ns-3.47/src/internet-apps/model/dhcp6-server.h
--- ns-3.46/src/internet-apps/model/dhcp6-server.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/model/dhcp6-server.h	2026-02-16 16:08:49.604230000 -0800
@@ -99,7 +99,7 @@
      * @brief Declined Addresses
      * Ipv6Address + Client DUID
      */
-    typedef std::unordered_map<Ipv6Address, Duid, Ipv6AddressHash> DeclinedAddresses;
+    typedef std::unordered_map<Ipv6Address, Duid> DeclinedAddresses;
 
     LeasedAddresses m_leasedAddresses;     //!< Leased addresses
     ExpiredAddresses m_expiredAddresses;   //!< Expired addresses
@@ -221,7 +221,6 @@
     void CleanLeases();
 
     Ptr<Socket> m_recvSocket;            //!< Socket bound to port 547.
-    Duid m_serverDuid;                   //!< Server DUID
     std::vector<LeaseInfo> m_subnets;    //!< List of managed subnets.
     Time m_leaseCleanup = Seconds(10.0); //!< Lease cleanup time
     EventId m_leaseCleanupEvent;         //!< Event ID for lease cleanup
@@ -260,6 +259,14 @@
      * Maximum value is REB_MAX_RT (RFC 8415, Section 7.6).
      */
     Time m_rebind;
+
+    Duid::Type m_duidType;             //!< DUID type.
+    uint16_t m_DuidEnIdentifierLength; //!< DUID-EN identifier length.
+
+    /**
+     * The server DUID, built by StartApplication() on fist usage.
+     */
+    Duid m_serverDuid;
 };
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/model/dhcp-client.cc ns-3.47/src/internet-apps/model/dhcp-client.cc
--- ns-3.46/src/internet-apps/model/dhcp-client.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/model/dhcp-client.cc	2026-02-16 16:08:49.603230000 -0800
@@ -166,12 +166,12 @@
     // Moreover, the length is always 16, because chaddr is 16 bytes.
     Address myAddress = m_device->GetAddress();
     NS_LOG_INFO("My address is " << myAddress);
-    uint8_t addr[Address::MAX_SIZE];
-    std::memset(addr, 0, Address::MAX_SIZE);
-    uint32_t len = myAddress.CopyTo(addr);
-    NS_ASSERT_MSG(len <= 16, "DHCP client can not handle a chaddr larger than 16 bytes");
-    m_chaddr.CopyFrom(addr, 16);
-    NS_LOG_INFO("My m_chaddr is " << m_chaddr);
+    NS_ASSERT_MSG(myAddress.GetLength() <= 16,
+                  "DHCP client can not handle a chaddr larger than 16 bytes");
+
+    m_chaddr.fill(0);
+    myAddress.CopyTo(m_chaddr.data());
+    NS_LOG_INFO("My Chaddr is " << DhcpChaddrToString(m_chaddr));
 
     bool found = false;
     for (uint32_t i = 0; i < ipv4->GetNAddresses(ifIndex); i++)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/model/dhcp-client.h ns-3.47/src/internet-apps/model/dhcp-client.h
--- ns-3.46/src/internet-apps/model/dhcp-client.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/model/dhcp-client.h	2026-02-16 16:08:49.603230000 -0800
@@ -140,7 +140,7 @@
     Ipv4Address m_remoteAddress;  //!< Initially set to 255.255.255.255 to start DHCP
     Ipv4Address m_offeredAddress; //!< Address offered to the client
     Ipv4Address m_myAddress;      //!< Address assigned to the client
-    Address m_chaddr;         //!< chaddr of the interface (stored as an Address for convenience).
+    DhcpChaddr m_chaddr{};    //!< chaddr of the interface (stored as an Address for convenience).
     Ipv4Mask m_myMask;        //!< Mask of the address assigned
     Ipv4Address m_server;     //!< Address of the DHCP server
     Ipv4Address m_gateway;    //!< Address of the gateway
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/model/dhcp-header.cc ns-3.47/src/internet-apps/model/dhcp-header.cc
--- ns-3.46/src/internet-apps/model/dhcp-header.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/model/dhcp-header.cc	2026-02-16 16:08:49.604230000 -0800
@@ -17,12 +17,35 @@
 #include "ns3/log.h"
 #include "ns3/simulator.h"
 
+#include <iomanip>
+#include <sstream>
+
+/**
+ * @file
+ * @ingroup internet-apps
+ * DhcpHeader classes implementation.
+ */
+
 namespace ns3
 {
 
 NS_LOG_COMPONENT_DEFINE("DhcpHeader");
 NS_OBJECT_ENSURE_REGISTERED(DhcpHeader);
 
+std::string
+DhcpChaddrToString(const DhcpChaddr& chaddr)
+{
+    std::ostringstream outStream;
+    outStream.fill('0');
+    outStream.setf(std::ios::hex, std::ios::basefield);
+
+    for (std::size_t i = 0; i < chaddr.size(); ++i)
+    {
+        outStream << std::setw(2) << (uint32_t)chaddr[i] << (i < chaddr.size() - 1 ? ":" : "");
+    }
+    return outStream.str();
+}
+
 DhcpHeader::DhcpHeader()
 {
     m_hType = 1;
@@ -105,27 +128,15 @@
 }
 
 void
-DhcpHeader::SetChaddr(Address addr)
-{
-    std::memset(m_chaddr, 0, 16);
-    NS_ASSERT_MSG(addr.GetLength() <= 16, "Address length too big");
-    addr.CopyTo(m_chaddr);
-}
-
-void
-DhcpHeader::SetChaddr(uint8_t* addr, uint8_t len)
+DhcpHeader::SetChaddr(DhcpChaddr addr)
 {
-    std::memset(m_chaddr, 0, 16);
-    NS_ASSERT_MSG(len <= 16, "Address length too big");
-    std::memcpy(m_chaddr, addr, len);
+    m_chaddr = addr;
 }
 
-Address
+DhcpChaddr
 DhcpHeader::GetChaddr()
 {
-    Address addr;
-    addr.CopyFrom(m_chaddr, 16);
-    return addr;
+    return m_chaddr;
 }
 
 void
@@ -313,7 +324,7 @@
     WriteTo(i, m_yiAddr);
     WriteTo(i, m_siAddr);
     WriteTo(i, m_giAddr);
-    i.Write(m_chaddr, 16);
+    i.Write(m_chaddr.data(), 16);
     i.Write(m_sname, 64);
     i.Write(m_file, 128);
     i.Write(m_magic_cookie, 4);
@@ -390,7 +401,7 @@
     ReadFrom(i, m_yiAddr);
     ReadFrom(i, m_siAddr);
     ReadFrom(i, m_giAddr);
-    i.Read(m_chaddr, 16);
+    i.Read(m_chaddr.data(), 16);
     i.Read(m_sname, 64);
     i.Read(m_file, 128);
     i.Read(m_magic_cookie, 4);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/model/dhcp-header.h ns-3.47/src/internet-apps/model/dhcp-header.h
--- ns-3.46/src/internet-apps/model/dhcp-header.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/model/dhcp-header.h	2026-02-16 16:08:49.604230000 -0800
@@ -18,6 +18,14 @@
 #include "ns3/header.h"
 #include "ns3/ipv4-address.h"
 
+#include <array>
+
+/**
+ * @file
+ * @ingroup internet-apps
+ * DhcpHeader classes declaration
+ */
+
 namespace ns3
 {
 
@@ -29,6 +37,24 @@
 /**
  * @ingroup dhcp
  *
+ * This is the Chaddr field, which is 16 bytes long. Originally it was
+ * meant to hold the Client Hardware Address (hence the name), but later RFCs
+ * refers to it just as the Client Identifier.
+ */
+using DhcpChaddr = std::array<uint8_t, 16>;
+
+/**
+ * @ingroup dhcp
+ * Function to pretty-print a Chaddr.
+ *
+ * @param chaddr the Chaddr
+ * @return A formatted string
+ */
+std::string DhcpChaddrToString(const DhcpChaddr& chaddr);
+
+/**
+ * @ingroup dhcp
+ *
  * @class DhcpHeader
  * @brief BOOTP header with DHCP messages.  This supports the following options:
  *        Subnet Mask (1), Address Request (50), Refresh Lease Time (51),
@@ -149,20 +175,11 @@
     void SetTime();
 
     /**
-     * @brief Set the Address of the device.
+     * @brief Set the Chaddress of the device.
      *
-     * Only the relevant bits are considered (i.e., not the type and length)
-     *
-     * @param addr Address of the device
-     */
-    void SetChaddr(Address addr);
-
-    /**
-     * @brief Set the Address of the device
      * @param addr Address of the device
-     * @param len Address length
      */
-    void SetChaddr(uint8_t* addr, uint8_t len);
+    void SetChaddr(DhcpChaddr addr);
 
     /**
      * @brief Get the Address of the client.
@@ -171,7 +188,7 @@
      *
      * @return Address of the client
      */
-    Address GetChaddr();
+    DhcpChaddr GetChaddr();
 
     /**
      * @brief Set the IPv4Address of the client
@@ -291,7 +308,7 @@
     uint32_t m_len;            //!< The length of the header
     uint16_t m_secs;           //!< Seconds elapsed
     uint16_t m_flags;          //!< BOOTP flags
-    uint8_t m_chaddr[16];      //!< The address identifier
+    DhcpChaddr m_chaddr;       //!< The client identifier
     Ipv4Address m_yiAddr;      //!< Your (client) IP address
     Ipv4Address m_ciAddr;      //!< The IP address of the client
     Ipv4Address m_siAddr;      //!< Next Server IP address
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/model/dhcp-server.cc ns-3.47/src/internet-apps/model/dhcp-server.cc
--- ns-3.46/src/internet-apps/model/dhcp-server.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/model/dhcp-server.cc	2026-02-16 16:08:49.604230000 -0800
@@ -24,6 +24,7 @@
 #include "ns3/socket.h"
 
 #include <algorithm>
+#include <limits>
 
 namespace ns3
 {
@@ -133,7 +134,8 @@
             // set infinite GRANTED_LEASED_TIME for my address
 
             myOwnAddress = ipv4->GetAddress(ifIndex, addrIndex).GetLocal();
-            m_leasedAddresses[Address()] = std::make_pair(myOwnAddress, 0xffffffff);
+            DhcpChaddr null = {};
+            m_leasedAddresses[null] = std::make_pair(myOwnAddress, PERMANENT_LEASE);
             break;
         }
     }
@@ -181,19 +183,18 @@
     NS_LOG_FUNCTION(this);
 
     // Set up timeout events and release of unsolicited addresses from the list
-    LeasedAddressIter i;
-    for (i = m_leasedAddresses.begin(); i != m_leasedAddresses.end(); i++)
+    for (auto [k, v] : m_leasedAddresses)
     {
         // update the address state
-        if (i->second.second != 0xffffffff && i->second.second != 0)
+        if (v.second != PERMANENT_LEASE && v.second != 0)
         {
-            i->second.second--;
-            if (i->second.second == 0)
+            v.second--;
+            if (v.second == 0)
             {
                 NS_LOG_INFO("Address leased state expired, address removed - "
-                            << "chaddr: " << i->first << " IP address " << i->second.first);
-                i->second.second = 0;
-                m_expiredAddresses.push_front(i->first);
+                            << "chaddr: " << DhcpChaddrToString(k) << " IP address " << v.first);
+                v.second = 0;
+                m_expiredAddresses.push_front(k);
             }
         }
     }
@@ -241,7 +242,7 @@
     NS_LOG_FUNCTION(this << iDev << header << from);
 
     DhcpHeader newDhcpHeader;
-    Address sourceChaddr = header.GetChaddr();
+    DhcpChaddr sourceChaddr = header.GetChaddr();
     uint32_t tran = header.GetTran();
     Ptr<Packet> packet = nullptr;
     Ipv4Address offeredAddress;
@@ -253,11 +254,11 @@
     {
         // We know this client from some time ago
         if (m_leasedAddresses[sourceChaddr].second != 0 &&
-            m_leasedAddresses[sourceChaddr].second != 0xffffffff)
+            m_leasedAddresses[sourceChaddr].second != PERMANENT_LEASE)
         {
             NS_LOG_LOGIC("This client is sending a DISCOVER but it has still a lease active - "
                          "perhaps it didn't shut down gracefully: "
-                         << sourceChaddr);
+                         << DhcpChaddrToString(sourceChaddr));
         }
 
         m_expiredAddresses.remove(sourceChaddr);
@@ -277,7 +278,7 @@
             // there's still hope: reuse the old ones.
             if (!m_expiredAddresses.empty())
             {
-                Address oldestChaddr = m_expiredAddresses.back();
+                DhcpChaddr oldestChaddr = m_expiredAddresses.back();
                 m_expiredAddresses.pop_back();
                 offeredAddress = m_leasedAddresses[oldestChaddr].first;
                 m_leasedAddresses.erase(oldestChaddr);
@@ -334,7 +335,7 @@
     NS_LOG_FUNCTION(this << iDev << header << from);
 
     DhcpHeader newDhcpHeader;
-    Address sourceChaddr = header.GetChaddr();
+    DhcpChaddr sourceChaddr = header.GetChaddr();
     uint32_t tran = header.GetTran();
     Ptr<Packet> packet = nullptr;
     Ipv4Address address = header.GetReq();
@@ -342,8 +343,7 @@
     NS_LOG_INFO("DHCP REQUEST from: " << from.GetIpv4() << " source port: " << from.GetPort()
                                       << " - refreshed addr: " << address);
 
-    LeasedAddressIter iter;
-    iter = m_leasedAddresses.find(sourceChaddr);
+    auto iter = m_leasedAddresses.find(sourceChaddr);
     if (iter != m_leasedAddresses.end())
     {
         // update the lease time of this address - send ACK
@@ -393,25 +393,20 @@
 }
 
 void
-DhcpServer::AddStaticDhcpEntry(Address chaddr, Ipv4Address addr)
+DhcpServer::AddStaticDhcpEntry(Address macAddr, Ipv4Address addr)
 {
-    NS_LOG_FUNCTION(this << chaddr << addr);
-    Address cleanedCaddr;
+    NS_LOG_FUNCTION(this << macAddr << addr);
+    DhcpChaddr chAddr{};
 
     NS_ASSERT_MSG(addr.Get() >= m_minAddress.Get() && addr.Get() <= m_maxAddress.Get(),
                   "Required address is not in the pool " << addr << " is not in [" << m_minAddress
                                                          << ", " << m_maxAddress << "]");
+    NS_ASSERT_MSG(macAddr.GetLength() <= 16,
+                  "DHCP server can not handle a chaddr larger than 16 bytes");
+    macAddr.CopyTo(chAddr.data());
 
-    // We need to cleanup the type from the stored chaddr, or later we'll fail to compare it.
-    // Moreover, the length is always 16, because chaddr is 16 bytes.
-    uint8_t buffer[Address::MAX_SIZE];
-    std::memset(buffer, 0, Address::MAX_SIZE);
-    uint32_t len = chaddr.CopyTo(buffer);
-    NS_ASSERT_MSG(len <= 16, "DHCP server can not handle a chaddr larger than 16 bytes");
-    cleanedCaddr.CopyFrom(buffer, 16);
-
-    NS_ASSERT_MSG(m_leasedAddresses.find(cleanedCaddr) == m_leasedAddresses.end(),
-                  "Client has already an active lease: " << m_leasedAddresses[cleanedCaddr].first);
+    NS_ASSERT_MSG(m_leasedAddresses.find(chAddr) == m_leasedAddresses.end(),
+                  "Client has already an active lease: " << m_leasedAddresses[chAddr].first);
 
     auto it = find(m_availableAddresses.begin(), m_availableAddresses.end(), addr);
     NS_ASSERT_MSG(
@@ -419,7 +414,8 @@
         "Required address is not available (perhaps it has been already assigned): " << addr);
 
     m_availableAddresses.remove(addr);
-    m_leasedAddresses[cleanedCaddr] = std::make_pair(addr, 0xffffffff);
+    NS_LOG_INFO("Added a static lease for " << DhcpChaddrToString(chAddr) << " -> " << addr);
+    m_leasedAddresses[chAddr] = std::make_pair(addr, PERMANENT_LEASE);
 }
 
 } // Namespace ns3
